'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _util = require('../util');

var Maybe = function Maybe(v) {
  if (v == null) {
    return new Nothing();
  }
  return new Just(v);
};

exports.Maybe = Maybe;
Maybe.of = function (v) {
  if (v instanceof Maybe) {
    return v;
  }
  return new Maybe(v);
};

var Just = (0, _util.inherit)(Maybe, function (v) {
  this.value = v;
});

exports.Just = Just;
Just.prototype.map = function (f) {
  return new Maybe(f(this.value));
};

Just.prototype.extract = function () {
  return this.value;
};
Just.prototype.ap = function (v) {
  return new Maybe(this.value(v));
};

Just.prototype.toString = function () {
  return 'Just';
};

var Nothing = (0, _util.inherit)(Maybe, function () {
  this.value = undefined;
});

exports.Nothing = Nothing;
Nothing.prototype.map = function () {
  return new Nothing();
};
Nothing.prototype.ap = function () {
  return this;
};
Nothing.prototype.extract = function () {
  return undefined;
};

Nothing.prototype.toString = function () {
  return 'Nothing';
};